
#include <objbase.h>

#include "lg/script.h"
#include "lg/scrmanagers.h"


class cScriptModule : public IScriptModule
{
public:
	// IUnknown
	STDMETHOD(QueryInterface)(REFIID,void**);
	STDMETHOD_(ULONG,AddRef)(void);
	STDMETHOD_(ULONG,Release)(void);
	// IScriptModule
	STDMETHOD_(const char*,GetName)(void);
	STDMETHOD_(const sScrClassDesc*,GetFirstClass)(tScrIter*);
	STDMETHOD_(const sScrClassDesc*,GetNextClass)(tScrIter*);
	STDMETHOD_(void,EndClassIter)(tScrIter*);

private:
	int m_iRef;

public:
	virtual ~cScriptModule();
	cScriptModule();
	cScriptModule(char* pszName);

	void SetName(char* pszName)
	{
		m_pszName = pszName;
	}

private:
	const sScrClassDesc* GetScript(unsigned int i);
	
	char* m_pszName;
	unsigned int m_iCurIndex;

	static const sScrClassDesc sm_ScriptsArray[];
	static const unsigned int sm_ScriptsArraySize;
};

extern cScriptModule  g_ScriptModule;


